#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n,q;
    cin>>n>>q;
    vector<int> niz(n);
    vector<int> nule;
    bool jeste=true;
    for(int i=0;i<n;i++){
        cin>>niz[i];
        if(niz[i]==0){
            nule.push_back(i+1);
        }
        if(niz[i]!=1 && niz[i]!=0) jeste=false;
    }
    sort(nule.begin(),nule.end());
    cout<<" ";
    while(q--){
        int l,r;
        cin>>l>>r;
        if(jeste){
            auto nes=lower_bound(nule.begin(),nule.end(),l);
            if(nes==nule.end()){
                cout<<1<<endl;
                continue;
            }
            int prva=*nes;
    //        cout<<prva<<" ";
        //    cout<<prva<<" "<<druga<<" ";
            if(prva>r){
                cout<<1<<endl;
            }else{
                cout<<0<<endl;
            }
        }else{
            int rez=niz[l-1];
            for(int i=l;i<r;i++){
       //         cout<<rez<<endl;
                rez&=niz[i];
            }
            cout<<rez<<endl;
        }
    }
    return 0;
}